
// // // // // // // // // // // // // // // //
//
//	FateMonitor.c++
//
//	created October 5th,97 by Andreas Warnke
//	last mod October 6th,97 by Andreas Warnke
//
//	description of the module:
//	FateMonitor ist die BView, die das
//	Schieberegister anzeigt.
//



// // // // // // // // // // // // // // // //
//
//	include
//

#include "main.h"
#include "FateMonitor.h"
#include "FateMaker.h"
#include <View.h>



// // // // // // // // // // // // // // // //
//
//	Konstruktor:
//

FateMonitor :: FateMonitor ( BRect inRect )
	: BView (
		inRect, 	//	Bounds Rectangle
		"FateMonitor", 	//	Name
		B_FOLLOW_ALL_SIDES, 	//	Resizing-Mode
		B_PULSE_NEEDED)
{
	//	Generator initialisieren:
	random = new FateMaker();
};



// // // // // // // // // // // // // // // //
//
//	Destruktor:
//

FateMonitor :: ~FateMonitor ( void )
{
	//	Generator löschen:
	if ( random != NULL )
		delete random;
	random = NULL;
};



// // // // // // // // // // // // // // // //
//
//	Draw:
//

void FateMonitor :: Draw ( BRect inRect )
{
	if (random != NULL)
	{
		for ( 
			int i = 0 ;
			i <= ( inRect.Width() * inRect.Height() ) / 100 / FRectSize / FRectSize ;
			i ++ )
		{
			//	Random Pixelposition:
			float x1 = random -> GetLong( inRect.Width() - FRectSize + PixelSize +1);
			float y1 = random -> GetLong( inRect.Height() - FRectSize + PixelSize+1);
			float x2 = x1 + FRectSize - PixelSize;
			float y2 = y1 + FRectSize - PixelSize;
			SetHighColor ( 
				random -> GetLong(0x100),
				random -> GetLong(0x100),
				random -> GetLong(0x100));
			FillRect( BRect ( x1, y1, x2, y2 ) );
		};
	};
		
	
	//	ErrorMessage:
	if (random == NULL)
	{
		SetHighColor ( 0xff, 0x00, 0x00 );
		FillRect ( inRect );
		SetHighColor ( 0xff, 0xff, 0x00 );
		SetLowColor ( 0xff, 0x00, 0x00 );
		MovePenTo(10,30);
		SetFont( be_bold_font );
		SetFontSize(16);
		DrawString("Sorry, out of memory.");
	};
};



// // // // // // // // // // // // // // // //
//
//	Pulse:
//

void FateMonitor :: Pulse ( void )
{
	//	Redraw:
	Draw( Frame() );
};



//
//	Ende.
//
// // // // // // // // // // // // // // // //
